---
product: "AG Charts"
title: "Financial Charts - Toolbar"
description: "The Toolbar contains tools that allow users to analyse and annotate the charts."
enterprise: true
framework: javascript
version: "14.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/financial-charts/"
    - title: "Configuration"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/financial-charts-configuration/"
    - title: "Range Buttons"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/range-buttons/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Financial Charts - Toolbar

The Toolbar contains tools that allow users to analyse and annotate the charts.

## Chart Type Selection

Users can choose the series type used to display the price data.

[Video](https://www.ag-grid.com/charts/archive/14.2.0/_astro/chart-types.ywAOF0mq.mp4)

Available series types are Candlestick, Hollow Candlestick, OHLC, Line, Step Line, HLC and High Low.

## Lines

#### Lines Drawings

```ts
import {
  AgCharts,
  AgFinancialChartOptions,
  FinancialChartModule,
  ModuleRegistry,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([FinancialChartModule]);

const options: AgFinancialChartOptions = {
  data: getData(),
  title: {
    text: "Line Drawings",
  },
  rangeButtons: false,
  initialState: {
    annotations: [
      {
        type: "line",
        start: {
          x: {
            __type: "date",
            value: "Thu Mar 21 2024 18:30:00 GMT+0000 (Greenwich Mean Time)",
          },
          y: 39859.35027982327,
        },
        end: {
          x: {
            __type: "date",
            value: "Thu Mar 21 2024 18:39:00 GMT+0000 (Greenwich Mean Time)",
          },
          y: 39836.36176730486,
        },
        text: {
          label: "Trend line",
          position: "center",
          alignment: "center",
        },
        extendStart: true,
        extendEnd: true,
      },
      {
        type: "parallel-channel",
        height: 15.282400589101599,
        middle: {
          strokeWidth: 1,
          lineDash: [6, 5],
        },
        background: {
          fill: "#5090dc",
          fillOpacity: 0.2,
        },
        start: {
          x: {
            __type: "date",
            value: "Thu Mar 21 2024 18:45:00 GMT+0000 (Greenwich Mean Time)",
          },
          y: 39831.539027982326,
        },
        end: {
          x: {
            __type: "date",
            value: "Thu Mar 21 2024 18:59:00 GMT+0000 (Greenwich Mean Time)",
          },
          y: 39842.30854197349,
        },
        text: {
          label: "Parallel channel",
          position: "top",
          alignment: "left",
        },
        extendStart: true,
      },
      {
        type: "disjoint-channel",
        startHeight: 29.948914431675803,
        endHeight: 12.78416347381426,
        start: {
          x: {
            __type: "date",
            value: "Thu Mar 21 2024 19:31:00 GMT+0000 (Greenwich Mean Time)",
          },
          y: 39843.62007363771,
        },
        end: {
          x: {
            __type: "date",
            value: "Thu Mar 21 2024 19:22:00 GMT+0000 (Greenwich Mean Time)",
          },
          y: 39835.032798232695,
        },
        text: {
          label: "Disjoint channel",
          position: "top",
          alignment: "right",
        },
      },
      {
        type: "vertical-line",
        value: {
          __type: "date",
          value: "Thu Mar 21 2024 19:08:00 GMT+0000 (Greenwich Mean Time)",
        },
        text: {
          label: "Vertical line",
          position: "top",
          alignment: "center",
        },
        axisLabel: {
          enabled: true,
        },
      },
      {
        type: "horizontal-line",
        value: 39863.48858615611,
        text: {
          label: "Horizontal line",
          position: "center",
          alignment: "right",
        },
        axisLabel: {
          enabled: true,
        },
        strokeWidth: 3,
        lineStyle: "dotted",
      },
    ],
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.createFinancialChart(options);
```

[Live example: Lines Drawings](https://www.ag-grid.com/charts/archive/14.2.0/typescript/financial-charts-toolbar/examples/line-drawings/)

Line types available are:

- **Trend Line**: A single line between two points on the chart.
- **Horizontal Line**: A horizontal line across the entire chart. There is also an optional label over the axis.
- **Vertical Line**: A vertical line across the entire chart. There is also an optional label over the axis.
- **Parallel Channel**: Two parallel lines, with a fill between them and an optional centre line as well.
- **Disjoint Channel**: Two lines which do not need to be parallel, with a fill between them.

Stroke and fill colours, stroke width and line style are fully customisable by the user.

### Line and Channel Labels

Users can add labels to their lines using the options available from the 'Settings' button or by double-clicking a line or channel. These options allow styling and positioning the labels.

### Extending Lines and Channels

Users can extend one or both ends of lines and channels to infinity. This is done using the options available from the 'Settings' button or by double-clicking a line or channel.

## Annotations

#### Text Annotations

```ts
import {
  AgCharts,
  AgFinancialChartOptions,
  FinancialChartModule,
  ModuleRegistry,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([FinancialChartModule]);

const options: AgFinancialChartOptions = {
  data: getData(),
  title: {
    text: "Text Annotations",
  },
  rangeButtons: false,
  initialState: {
    annotations: [
      {
        type: "text",
        text: "Text",
        x: {
          __type: "date",
          value: "Thu Mar 21 2024 19:21:00 GMT+0000 (Greenwich Mean Time)",
        },
        y: 39851.06756756757,
      },
      {
        type: "comment",
        text: "Comment",
        x: {
          __type: "date",
          value: "Thu Mar 21 2024 19:06:00 GMT+0000 (Greenwich Mean Time)",
        },
        y: 39844.91891891892,
      },
      {
        type: "callout",
        text: "Callout",
        start: {
          x: {
            __type: "date",
            value: "Thu Mar 21 2024 18:31:00 GMT+0000 (Greenwich Mean Time)",
          },
          y: 39856.820512820515,
        },
        end: {
          x: {
            __type: "date",
            value: "Thu Mar 21 2024 18:39:00 GMT+0000 (Greenwich Mean Time)",
          },
          y: 39859.282051282054,
        },
      },
      {
        type: "note",
        text: "Note",
        x: {
          __type: "date",
          value: "Thu Mar 21 2024 18:54:00 GMT+0000 (Greenwich Mean Time)",
        },
        y: 39843.28205128205,
      },
    ],
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.createFinancialChart(options);
```

[Live example: Text Annotations](https://www.ag-grid.com/charts/archive/14.2.0/typescript/financial-charts-toolbar/examples/text-annotations/)

Annotation types available are:

- **Text**: Simple text string displayed on the chart.
- **Comment**: Text within a comment box.
- **Callout**: Text within a box, with a callout arrow anchored to a specific position on the chart.
- **Note**: An icon on the chart, with text displayed on hover.

Add a new line within annotations by pressing `⇧ Shift`+`↵ Enter`.

## Arrows

#### Arrow Drawings

```ts
import {
  AgCharts,
  AgFinancialChartOptions,
  FinancialChartModule,
  ModuleRegistry,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([FinancialChartModule]);

const options: AgFinancialChartOptions = {
  data: getData(),
  title: {
    text: "Arrow Drawings",
  },
  rangeButtons: false,
  initialState: {
    annotations: [
      {
        type: "arrow",
        start: {
          x: {
            __type: "date",
            value: "Thu Mar 21 2024 18:25:00 GMT+0000 (Greenwich Mean Time)",
          },
          y: 39870.926928281464,
        },
        end: {
          x: {
            __type: "date",
            value: "Thu Mar 21 2024 18:44:00 GMT+0000 (Greenwich Mean Time)",
          },
          y: 39827.35453315291,
        },
      },
      {
        type: "arrow-up",
        x: {
          __type: "date",
          value: "Thu Mar 21 2024 18:56:00 GMT+0000 (Greenwich Mean Time)",
        },
        y: 39842.13125845738,
      },
      {
        type: "arrow-down",
        x: {
          __type: "date",
          value: "Thu Mar 21 2024 19:11:00 GMT+0000 (Greenwich Mean Time)",
        },
        y: 39814.188092016244,
      },
    ],
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.createFinancialChart(options);
```

[Live example: Arrow Drawings](https://www.ag-grid.com/charts/archive/14.2.0/typescript/financial-charts-toolbar/examples/arrow-drawings/)

Arrow types available are:

- **Arrow**: An arrow extending between two points on the chart.
- **Arrow Up**: A fixed size up arrow in a specific position on the chart.
- **Arrow Down**: A fixed size down arrow in a specific position on the chart.

## Fibonacci Tools

#### Fibonacci Tools

```ts
import {
  AgCharts,
  AgFinancialChartOptions,
  FinancialChartModule,
  ModuleRegistry,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([FinancialChartModule]);

const options: AgFinancialChartOptions = {
  data: getData(),
  title: {
    text: "Fibonacci Tools",
  },
  rangeButtons: false,
  initialState: {
    annotations: [
      {
        type: "fibonacci-retracement",
        start: {
          x: {
            __type: "date",
            value: "2024-03-21T19:30:00.000Z",
          },
          y: 39839.65593310556,
        },
        end: {
          x: {
            __type: "date",
            value: "2024-03-21T19:12:00.000Z",
          },
          y: 39830.30360752416,
        },
      },
      {
        type: "fibonacci-retracement-trend-based",
        endRetracement: {
          x: {
            __type: "date",
            value: "2024-03-21T18:59:00.000Z",
          },
          y: 39824.246612868774,
        },
        start: {
          x: {
            __type: "date",
            value: "2024-03-21T18:38:00.000Z",
          },
          y: 39822.62080641716,
        },
        end: {
          x: {
            __type: "date",
            value: "2024-03-21T18:47:00.000Z",
          },
          y: 39830.20790319135,
        },
      },
    ],
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.createFinancialChart(options);
```

[Live example: Fibonacci Tools](https://www.ag-grid.com/charts/archive/14.2.0/typescript/financial-charts-toolbar/examples/fibonacci-tools/)

- **Fibonacci Retracement**: Multiple Fibonacci bands based on the distance between two points on the chart. Users have the option to choose how many bands to show.
- **Fibonacci Trend Based**: Multiple Fibonacci bands derived from the proportional relationships between three key points, capturing potential support and resistance zones along the trend. Users have the option to choose how many bands to show.

## Measuring Tools

#### Measuring Tools

```ts
import {
  AgCharts,
  AgFinancialChartOptions,
  FinancialChartModule,
  ModuleRegistry,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([FinancialChartModule]);

const options: AgFinancialChartOptions = {
  data: getData(),
  title: {
    text: "Measuring Tools",
  },
  rangeButtons: false,
  initialState: {
    annotations: [
      {
        type: "date-range",
        extendBelow: true,
        text: {
          label: "Date Range",
          position: "top",
          alignment: "center",
        },
        start: {
          x: {
            __type: "date",
            value: "Thu Mar 21 2024 18:29:00 GMT+0000 (Greenwich Mean Time)",
          },
          y: 39863.005115089516,
        },
        end: {
          x: {
            __type: "date",
            value: "Thu Mar 21 2024 18:41:00 GMT+0000 (Greenwich Mean Time)",
          },
          y: 39840.089514066494,
        },
      },
      {
        type: "price-range",
        text: {
          label: "Price Range",
          position: "top",
          alignment: "right",
        },
        start: {
          x: {
            __type: "date",
            value: "Thu Mar 21 2024 18:57:00 GMT+0000 (Greenwich Mean Time)",
          },
          y: 39822.54475703325,
        },
        end: {
          x: {
            __type: "date",
            value: "Thu Mar 21 2024 18:49:00 GMT+0000 (Greenwich Mean Time)",
          },
          y: 39839.373401534525,
        },
      },
      {
        type: "date-price-range",
        text: {
          label: "Date and Price Range",
          position: "center",
          alignment: "left",
        },
        start: {
          x: {
            __type: "date",
            value: "Thu Mar 21 2024 19:02:00 GMT+0000 (Greenwich Mean Time)",
          },
          y: 39834.62915601023,
        },
        end: {
          x: {
            __type: "date",
            value: "Thu Mar 21 2024 19:31:00 GMT+0000 (Greenwich Mean Time)",
          },
          y: 39844.833759590794,
        },
      },
    ],
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.createFinancialChart(options);
```

[Live example: Measuring Tools](https://www.ag-grid.com/charts/archive/14.2.0/typescript/financial-charts-toolbar/examples/measuring-tools/)

Measuring Tools available are:

- **Measure**: A quick measuring tool, which measures both the date and price range. This is removed when the user clicks away on the chart.
- **Date Range**: Measures the time difference and number of bars between two points on the chart. Also shows the sum of the volume between the two points if `volume` is enabled.
- **Price Range**: Measures the price difference between two points on the chart. This is displayed both as an absolute value and as a percentage.
- **Date and Price**: Combines both the Date and Price Range measures.

## Keyboard Shortcuts

The following keyboard shortcuts can be used with Financial Charts.

- `^ Ctrl`+`Z` will undo any drawing and annotation actions.
- `^ Ctrl`+`Y` will redo any undo actions.
- `^ Ctrl`+`C` will copy the selected drawing or annotation.
- `^ Ctrl`+`V` will paste the copied drawing or annotation.
- `Delete` or `⌫ Backspace` will delete the selected item.
- Arrow keys (`←` `↑` `→` `↓`) will move the selected drawing or annotation by 1 pixel.  
  Use in combination with `^ Ctrl` or `⇧ Shift` to move by 10 pixels.
- Holding down `⇧ Shift` whilst creating a drawing or dragging a handle will snap it to the nearest 45° angle.

## Save & Restore

Drawings and Annotations can be saved, restored and programmatically initialised and modified, using the [Chart State API](https://www.ag-grid.com/charts/archive/14.2.0/javascript/api-state/).

## Customisation

#### Annotation Customisation

```ts
import {
  AgCharts,
  AgFinancialChartOptions,
  FinancialChartModule,
  ModuleRegistry,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([FinancialChartModule]);

const options: AgFinancialChartOptions = {
  data: getData(),
  title: {
    text: "Customisation",
  },
  rangeButtons: false,
  theme: {
    overrides: {
      common: {
        annotations: {
          line: {
            stroke: "lime",
            strokeWidth: 3,
            lineDash: [3, 4],
          },
          "parallel-channel": {
            stroke: "red",
            strokeWidth: 4,
            background: {
              fill: "red",
            },
            middle: {
              strokeOpacity: 0,
            },
          },
          comment: {
            fill: "orange",
            color: "blue",
            stroke: "blue",
            strokeWidth: 2,
          },
        },
      },
    },
  },
  initialState: {
    annotations: [
      {
        type: "parallel-channel",
        height: 83.55795148247944,
        start: {
          x: {
            __type: "date",
            value: "Tue Sep 19 2023 00:00:00 GMT+0100 (British Summer Time)",
          },
          y: 4401.88679245283,
        },
        end: {
          x: {
            __type: "date",
            value: "Thu Oct 05 2023 00:00:00 GMT+0100 (British Summer Time)",
          },
          y: 4279.245283018868,
        },
      },
      {
        type: "line",
        start: {
          x: {
            __type: "date",
            value: "Tue Sep 05 2023 00:00:00 GMT+0100 (British Summer Time)",
          },
          y: 4507.681940700809,
        },
        end: {
          x: {
            __type: "date",
            value: "Fri Oct 13 2023 00:00:00 GMT+0100 (British Summer Time)",
          },
          y: 4331.805929919137,
        },
      },
      {
        type: "comment",
        text: "Comment",
        visible: true,
        x: {
          __type: "date",
          value: "Tue Aug 22 2023 00:00:00 GMT+0100 (British Summer Time)",
        },
        y: 4261.725067385445,
      },
    ],
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.createFinancialChart(options);
```

[Live example: Annotation Customisation](https://www.ag-grid.com/charts/archive/14.2.0/typescript/financial-charts-toolbar/examples/annotation-customisation/)

To customise the look of Drawings and Annotations, use [Theme Override Options](https://www.ag-grid.com/charts/archive/14.2.0/themes-api/#reference-AgChartTheme-overrides-common-annotations).

```js
{
    theme: {
        overrides: {
            common: {
                annotations: {
                    line: {
                        stroke: 'lime',
                        strokeWidth: 3,
                        lineDash: [3, 4],
                    },
                    'parallel-channel': {
                        stroke: 'red',
                        strokeWidth: 4,
                        background: {
                            fill: 'red',
                        },
                        middle: {
                            strokeOpacity: 0,
                        },
                    },
                    comment: {
                        fill: 'orange',
                        color: 'blue',
                        strokeWidth: 4,
                    },
                },
            },
        },
    },
}
```


---
product: "AG Charts"
title: "Financial Charts - Toolbar"
description: "The Toolbar contains tools that allow users to analyse and annotate the charts."
enterprise: true
framework: react
version: "14.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/financial-charts/"
    - title: "Configuration"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/financial-charts-configuration/"
    - title: "Range Buttons"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/range-buttons/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Financial Charts - Toolbar

The Toolbar contains tools that allow users to analyse and annotate the charts.

## Chart Type Selection

Users can choose the series type used to display the price data.

[Video](https://www.ag-grid.com/charts/archive/14.2.0/_astro/chart-types.ywAOF0mq.mp4)

Available series types are Candlestick, Hollow Candlestick, OHLC, Line, Step Line, HLC and High Low.

## Lines

#### Lines Drawings

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgFinancialCharts } from "ag-charts-react";
import {
  AgFinancialChartOptions,
  FinancialChartModule,
  ModuleRegistry,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([FinancialChartModule]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgFinancialChartOptions>({
    data: getData(),
    title: {
      text: "Line Drawings",
    },
    rangeButtons: false,
    initialState: {
      annotations: [
        {
          type: "line",
          start: {
            x: {
              __type: "date",
              value: "Thu Mar 21 2024 18:30:00 GMT+0000 (Greenwich Mean Time)",
            },
            y: 39859.35027982327,
          },
          end: {
            x: {
              __type: "date",
              value: "Thu Mar 21 2024 18:39:00 GMT+0000 (Greenwich Mean Time)",
            },
            y: 39836.36176730486,
          },
          text: {
            label: "Trend line",
            position: "center",
            alignment: "center",
          },
          extendStart: true,
          extendEnd: true,
        },
        {
          type: "parallel-channel",
          height: 15.282400589101599,
          middle: {
            strokeWidth: 1,
            lineDash: [6, 5],
          },
          background: {
            fill: "#5090dc",
            fillOpacity: 0.2,
          },
          start: {
            x: {
              __type: "date",
              value: "Thu Mar 21 2024 18:45:00 GMT+0000 (Greenwich Mean Time)",
            },
            y: 39831.539027982326,
          },
          end: {
            x: {
              __type: "date",
              value: "Thu Mar 21 2024 18:59:00 GMT+0000 (Greenwich Mean Time)",
            },
            y: 39842.30854197349,
          },
          text: {
            label: "Parallel channel",
            position: "top",
            alignment: "left",
          },
          extendStart: true,
        },
        {
          type: "disjoint-channel",
          startHeight: 29.948914431675803,
          endHeight: 12.78416347381426,
          start: {
            x: {
              __type: "date",
              value: "Thu Mar 21 2024 19:31:00 GMT+0000 (Greenwich Mean Time)",
            },
            y: 39843.62007363771,
          },
          end: {
            x: {
              __type: "date",
              value: "Thu Mar 21 2024 19:22:00 GMT+0000 (Greenwich Mean Time)",
            },
            y: 39835.032798232695,
          },
          text: {
            label: "Disjoint channel",
            position: "top",
            alignment: "right",
          },
        },
        {
          type: "vertical-line",
          value: {
            __type: "date",
            value: "Thu Mar 21 2024 19:08:00 GMT+0000 (Greenwich Mean Time)",
          },
          text: {
            label: "Vertical line",
            position: "top",
            alignment: "center",
          },
          axisLabel: {
            enabled: true,
          },
        },
        {
          type: "horizontal-line",
          value: 39863.48858615611,
          text: {
            label: "Horizontal line",
            position: "center",
            alignment: "right",
          },
          axisLabel: {
            enabled: true,
          },
          strokeWidth: 3,
          lineStyle: "dotted",
        },
      ],
    },
  });

  return <AgFinancialCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Lines Drawings](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/financial-charts-toolbar/examples/line-drawings/)

Line types available are:

- **Trend Line**: A single line between two points on the chart.
- **Horizontal Line**: A horizontal line across the entire chart. There is also an optional label over the axis.
- **Vertical Line**: A vertical line across the entire chart. There is also an optional label over the axis.
- **Parallel Channel**: Two parallel lines, with a fill between them and an optional centre line as well.
- **Disjoint Channel**: Two lines which do not need to be parallel, with a fill between them.

Stroke and fill colours, stroke width and line style are fully customisable by the user.

### Line and Channel Labels

Users can add labels to their lines using the options available from the 'Settings' button or by double-clicking a line or channel. These options allow styling and positioning the labels.

### Extending Lines and Channels

Users can extend one or both ends of lines and channels to infinity. This is done using the options available from the 'Settings' button or by double-clicking a line or channel.

## Annotations

#### Text Annotations

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgFinancialCharts } from "ag-charts-react";
import {
  AgFinancialChartOptions,
  FinancialChartModule,
  ModuleRegistry,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([FinancialChartModule]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgFinancialChartOptions>({
    data: getData(),
    title: {
      text: "Text Annotations",
    },
    rangeButtons: false,
    initialState: {
      annotations: [
        {
          type: "text",
          text: "Text",
          x: {
            __type: "date",
            value: "Thu Mar 21 2024 19:21:00 GMT+0000 (Greenwich Mean Time)",
          },
          y: 39851.06756756757,
        },
        {
          type: "comment",
          text: "Comment",
          x: {
            __type: "date",
            value: "Thu Mar 21 2024 19:06:00 GMT+0000 (Greenwich Mean Time)",
          },
          y: 39844.91891891892,
        },
        {
          type: "callout",
          text: "Callout",
          start: {
            x: {
              __type: "date",
              value: "Thu Mar 21 2024 18:31:00 GMT+0000 (Greenwich Mean Time)",
            },
            y: 39856.820512820515,
          },
          end: {
            x: {
              __type: "date",
              value: "Thu Mar 21 2024 18:39:00 GMT+0000 (Greenwich Mean Time)",
            },
            y: 39859.282051282054,
          },
        },
        {
          type: "note",
          text: "Note",
          x: {
            __type: "date",
            value: "Thu Mar 21 2024 18:54:00 GMT+0000 (Greenwich Mean Time)",
          },
          y: 39843.28205128205,
        },
      ],
    },
  });

  return <AgFinancialCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Text Annotations](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/financial-charts-toolbar/examples/text-annotations/)

Annotation types available are:

- **Text**: Simple text string displayed on the chart.
- **Comment**: Text within a comment box.
- **Callout**: Text within a box, with a callout arrow anchored to a specific position on the chart.
- **Note**: An icon on the chart, with text displayed on hover.

Add a new line within annotations by pressing `⇧ Shift`+`↵ Enter`.

## Arrows

#### Arrow Drawings

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgFinancialCharts } from "ag-charts-react";
import {
  AgFinancialChartOptions,
  FinancialChartModule,
  ModuleRegistry,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([FinancialChartModule]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgFinancialChartOptions>({
    data: getData(),
    title: {
      text: "Arrow Drawings",
    },
    rangeButtons: false,
    initialState: {
      annotations: [
        {
          type: "arrow",
          start: {
            x: {
              __type: "date",
              value: "Thu Mar 21 2024 18:25:00 GMT+0000 (Greenwich Mean Time)",
            },
            y: 39870.926928281464,
          },
          end: {
            x: {
              __type: "date",
              value: "Thu Mar 21 2024 18:44:00 GMT+0000 (Greenwich Mean Time)",
            },
            y: 39827.35453315291,
          },
        },
        {
          type: "arrow-up",
          x: {
            __type: "date",
            value: "Thu Mar 21 2024 18:56:00 GMT+0000 (Greenwich Mean Time)",
          },
          y: 39842.13125845738,
        },
        {
          type: "arrow-down",
          x: {
            __type: "date",
            value: "Thu Mar 21 2024 19:11:00 GMT+0000 (Greenwich Mean Time)",
          },
          y: 39814.188092016244,
        },
      ],
    },
  });

  return <AgFinancialCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Arrow Drawings](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/financial-charts-toolbar/examples/arrow-drawings/)

Arrow types available are:

- **Arrow**: An arrow extending between two points on the chart.
- **Arrow Up**: A fixed size up arrow in a specific position on the chart.
- **Arrow Down**: A fixed size down arrow in a specific position on the chart.

## Fibonacci Tools

#### Fibonacci Tools

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgFinancialCharts } from "ag-charts-react";
import {
  AgFinancialChartOptions,
  FinancialChartModule,
  ModuleRegistry,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([FinancialChartModule]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgFinancialChartOptions>({
    data: getData(),
    title: {
      text: "Fibonacci Tools",
    },
    rangeButtons: false,
    initialState: {
      annotations: [
        {
          type: "fibonacci-retracement",
          start: {
            x: {
              __type: "date",
              value: "2024-03-21T19:30:00.000Z",
            },
            y: 39839.65593310556,
          },
          end: {
            x: {
              __type: "date",
              value: "2024-03-21T19:12:00.000Z",
            },
            y: 39830.30360752416,
          },
        },
        {
          type: "fibonacci-retracement-trend-based",
          endRetracement: {
            x: {
              __type: "date",
              value: "2024-03-21T18:59:00.000Z",
            },
            y: 39824.246612868774,
          },
          start: {
            x: {
              __type: "date",
              value: "2024-03-21T18:38:00.000Z",
            },
            y: 39822.62080641716,
          },
          end: {
            x: {
              __type: "date",
              value: "2024-03-21T18:47:00.000Z",
            },
            y: 39830.20790319135,
          },
        },
      ],
    },
  });

  return <AgFinancialCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Fibonacci Tools](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/financial-charts-toolbar/examples/fibonacci-tools/)

- **Fibonacci Retracement**: Multiple Fibonacci bands based on the distance between two points on the chart. Users have the option to choose how many bands to show.
- **Fibonacci Trend Based**: Multiple Fibonacci bands derived from the proportional relationships between three key points, capturing potential support and resistance zones along the trend. Users have the option to choose how many bands to show.

## Measuring Tools

#### Measuring Tools

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgFinancialCharts } from "ag-charts-react";
import {
  AgFinancialChartOptions,
  FinancialChartModule,
  ModuleRegistry,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([FinancialChartModule]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgFinancialChartOptions>({
    data: getData(),
    title: {
      text: "Measuring Tools",
    },
    rangeButtons: false,
    initialState: {
      annotations: [
        {
          type: "date-range",
          extendBelow: true,
          text: {
            label: "Date Range",
            position: "top",
            alignment: "center",
          },
          start: {
            x: {
              __type: "date",
              value: "Thu Mar 21 2024 18:29:00 GMT+0000 (Greenwich Mean Time)",
            },
            y: 39863.005115089516,
          },
          end: {
            x: {
              __type: "date",
              value: "Thu Mar 21 2024 18:41:00 GMT+0000 (Greenwich Mean Time)",
            },
            y: 39840.089514066494,
          },
        },
        {
          type: "price-range",
          text: {
            label: "Price Range",
            position: "top",
            alignment: "right",
          },
          start: {
            x: {
              __type: "date",
              value: "Thu Mar 21 2024 18:57:00 GMT+0000 (Greenwich Mean Time)",
            },
            y: 39822.54475703325,
          },
          end: {
            x: {
              __type: "date",
              value: "Thu Mar 21 2024 18:49:00 GMT+0000 (Greenwich Mean Time)",
            },
            y: 39839.373401534525,
          },
        },
        {
          type: "date-price-range",
          text: {
            label: "Date and Price Range",
            position: "center",
            alignment: "left",
          },
          start: {
            x: {
              __type: "date",
              value: "Thu Mar 21 2024 19:02:00 GMT+0000 (Greenwich Mean Time)",
            },
            y: 39834.62915601023,
          },
          end: {
            x: {
              __type: "date",
              value: "Thu Mar 21 2024 19:31:00 GMT+0000 (Greenwich Mean Time)",
            },
            y: 39844.833759590794,
          },
        },
      ],
    },
  });

  return <AgFinancialCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Measuring Tools](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/financial-charts-toolbar/examples/measuring-tools/)

Measuring Tools available are:

- **Measure**: A quick measuring tool, which measures both the date and price range. This is removed when the user clicks away on the chart.
- **Date Range**: Measures the time difference and number of bars between two points on the chart. Also shows the sum of the volume between the two points if `volume` is enabled.
- **Price Range**: Measures the price difference between two points on the chart. This is displayed both as an absolute value and as a percentage.
- **Date and Price**: Combines both the Date and Price Range measures.

## Keyboard Shortcuts

The following keyboard shortcuts can be used with Financial Charts.

- `^ Ctrl`+`Z` will undo any drawing and annotation actions.
- `^ Ctrl`+`Y` will redo any undo actions.
- `^ Ctrl`+`C` will copy the selected drawing or annotation.
- `^ Ctrl`+`V` will paste the copied drawing or annotation.
- `Delete` or `⌫ Backspace` will delete the selected item.
- Arrow keys (`←` `↑` `→` `↓`) will move the selected drawing or annotation by 1 pixel.  
  Use in combination with `^ Ctrl` or `⇧ Shift` to move by 10 pixels.
- Holding down `⇧ Shift` whilst creating a drawing or dragging a handle will snap it to the nearest 45° angle.

## Save & Restore

Drawings and Annotations can be saved, restored and programmatically initialised and modified, using the [Chart State API](https://www.ag-grid.com/charts/archive/14.2.0/react/api-state/).

## Customisation

#### Annotation Customisation

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgFinancialCharts } from "ag-charts-react";
import {
  AgFinancialChartOptions,
  FinancialChartModule,
  ModuleRegistry,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([FinancialChartModule]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgFinancialChartOptions>({
    data: getData(),
    title: {
      text: "Customisation",
    },
    rangeButtons: false,
    theme: {
      overrides: {
        common: {
          annotations: {
            line: {
              stroke: "lime",
              strokeWidth: 3,
              lineDash: [3, 4],
            },
            "parallel-channel": {
              stroke: "red",
              strokeWidth: 4,
              background: {
                fill: "red",
              },
              middle: {
                strokeOpacity: 0,
              },
            },
            comment: {
              fill: "orange",
              color: "blue",
              stroke: "blue",
              strokeWidth: 2,
            },
          },
        },
      },
    },
    initialState: {
      annotations: [
        {
          type: "parallel-channel",
          height: 83.55795148247944,
          start: {
            x: {
              __type: "date",
              value: "Tue Sep 19 2023 00:00:00 GMT+0100 (British Summer Time)",
            },
            y: 4401.88679245283,
          },
          end: {
            x: {
              __type: "date",
              value: "Thu Oct 05 2023 00:00:00 GMT+0100 (British Summer Time)",
            },
            y: 4279.245283018868,
          },
        },
        {
          type: "line",
          start: {
            x: {
              __type: "date",
              value: "Tue Sep 05 2023 00:00:00 GMT+0100 (British Summer Time)",
            },
            y: 4507.681940700809,
          },
          end: {
            x: {
              __type: "date",
              value: "Fri Oct 13 2023 00:00:00 GMT+0100 (British Summer Time)",
            },
            y: 4331.805929919137,
          },
        },
        {
          type: "comment",
          text: "Comment",
          visible: true,
          x: {
            __type: "date",
            value: "Tue Aug 22 2023 00:00:00 GMT+0100 (British Summer Time)",
          },
          y: 4261.725067385445,
        },
      ],
    },
  });

  return <AgFinancialCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Annotation Customisation](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/financial-charts-toolbar/examples/annotation-customisation/)

To customise the look of Drawings and Annotations, use [Theme Override Options](https://www.ag-grid.com/charts/archive/14.2.0/themes-api/#reference-AgChartTheme-overrides-common-annotations).

```js
{
    theme: {
        overrides: {
            common: {
                annotations: {
                    line: {
                        stroke: 'lime',
                        strokeWidth: 3,
                        lineDash: [3, 4],
                    },
                    'parallel-channel': {
                        stroke: 'red',
                        strokeWidth: 4,
                        background: {
                            fill: 'red',
                        },
                        middle: {
                            strokeOpacity: 0,
                        },
                    },
                    comment: {
                        fill: 'orange',
                        color: 'blue',
                        strokeWidth: 4,
                    },
                },
            },
        },
    },
}
```


---
product: "AG Charts"
title: "Financial Charts - Toolbar"
description: "The Toolbar contains tools that allow users to analyse and annotate the charts."
enterprise: true
framework: angular
version: "14.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/financial-charts/"
    - title: "Configuration"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/financial-charts-configuration/"
    - title: "Range Buttons"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/range-buttons/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Financial Charts - Toolbar

The Toolbar contains tools that allow users to analyse and annotate the charts.

## Chart Type Selection

Users can choose the series type used to display the price data.

[Video](https://www.ag-grid.com/charts/archive/14.2.0/_astro/chart-types.ywAOF0mq.mp4)

Available series types are Candlestick, Hollow Candlestick, OHLC, Line, Step Line, HLC and High Low.

## Lines

#### Lines Drawings

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Lines Drawings](https://www.ag-grid.com/charts/archive/14.2.0/angular/financial-charts-toolbar/examples/line-drawings/)

Line types available are:

- **Trend Line**: A single line between two points on the chart.
- **Horizontal Line**: A horizontal line across the entire chart. There is also an optional label over the axis.
- **Vertical Line**: A vertical line across the entire chart. There is also an optional label over the axis.
- **Parallel Channel**: Two parallel lines, with a fill between them and an optional centre line as well.
- **Disjoint Channel**: Two lines which do not need to be parallel, with a fill between them.

Stroke and fill colours, stroke width and line style are fully customisable by the user.

### Line and Channel Labels

Users can add labels to their lines using the options available from the 'Settings' button or by double-clicking a line or channel. These options allow styling and positioning the labels.

### Extending Lines and Channels

Users can extend one or both ends of lines and channels to infinity. This is done using the options available from the 'Settings' button or by double-clicking a line or channel.

## Annotations

#### Text Annotations

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Text Annotations](https://www.ag-grid.com/charts/archive/14.2.0/angular/financial-charts-toolbar/examples/text-annotations/)

Annotation types available are:

- **Text**: Simple text string displayed on the chart.
- **Comment**: Text within a comment box.
- **Callout**: Text within a box, with a callout arrow anchored to a specific position on the chart.
- **Note**: An icon on the chart, with text displayed on hover.

Add a new line within annotations by pressing `⇧ Shift`+`↵ Enter`.

## Arrows

#### Arrow Drawings

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Arrow Drawings](https://www.ag-grid.com/charts/archive/14.2.0/angular/financial-charts-toolbar/examples/arrow-drawings/)

Arrow types available are:

- **Arrow**: An arrow extending between two points on the chart.
- **Arrow Up**: A fixed size up arrow in a specific position on the chart.
- **Arrow Down**: A fixed size down arrow in a specific position on the chart.

## Fibonacci Tools

#### Fibonacci Tools

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Fibonacci Tools](https://www.ag-grid.com/charts/archive/14.2.0/angular/financial-charts-toolbar/examples/fibonacci-tools/)

- **Fibonacci Retracement**: Multiple Fibonacci bands based on the distance between two points on the chart. Users have the option to choose how many bands to show.
- **Fibonacci Trend Based**: Multiple Fibonacci bands derived from the proportional relationships between three key points, capturing potential support and resistance zones along the trend. Users have the option to choose how many bands to show.

## Measuring Tools

#### Measuring Tools

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Measuring Tools](https://www.ag-grid.com/charts/archive/14.2.0/angular/financial-charts-toolbar/examples/measuring-tools/)

Measuring Tools available are:

- **Measure**: A quick measuring tool, which measures both the date and price range. This is removed when the user clicks away on the chart.
- **Date Range**: Measures the time difference and number of bars between two points on the chart. Also shows the sum of the volume between the two points if `volume` is enabled.
- **Price Range**: Measures the price difference between two points on the chart. This is displayed both as an absolute value and as a percentage.
- **Date and Price**: Combines both the Date and Price Range measures.

## Keyboard Shortcuts

The following keyboard shortcuts can be used with Financial Charts.

- `^ Ctrl`+`Z` will undo any drawing and annotation actions.
- `^ Ctrl`+`Y` will redo any undo actions.
- `^ Ctrl`+`C` will copy the selected drawing or annotation.
- `^ Ctrl`+`V` will paste the copied drawing or annotation.
- `Delete` or `⌫ Backspace` will delete the selected item.
- Arrow keys (`←` `↑` `→` `↓`) will move the selected drawing or annotation by 1 pixel.  
  Use in combination with `^ Ctrl` or `⇧ Shift` to move by 10 pixels.
- Holding down `⇧ Shift` whilst creating a drawing or dragging a handle will snap it to the nearest 45° angle.

## Save & Restore

Drawings and Annotations can be saved, restored and programmatically initialised and modified, using the [Chart State API](https://www.ag-grid.com/charts/archive/14.2.0/angular/api-state/).

## Customisation

#### Annotation Customisation

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Annotation Customisation](https://www.ag-grid.com/charts/archive/14.2.0/angular/financial-charts-toolbar/examples/annotation-customisation/)

To customise the look of Drawings and Annotations, use [Theme Override Options](https://www.ag-grid.com/charts/archive/14.2.0/themes-api/#reference-AgChartTheme-overrides-common-annotations).

```js
{
    theme: {
        overrides: {
            common: {
                annotations: {
                    line: {
                        stroke: 'lime',
                        strokeWidth: 3,
                        lineDash: [3, 4],
                    },
                    'parallel-channel': {
                        stroke: 'red',
                        strokeWidth: 4,
                        background: {
                            fill: 'red',
                        },
                        middle: {
                            strokeOpacity: 0,
                        },
                    },
                    comment: {
                        fill: 'orange',
                        color: 'blue',
                        strokeWidth: 4,
                    },
                },
            },
        },
    },
}
```


---
product: "AG Charts"
title: "Financial Charts - Toolbar"
description: "The Toolbar contains tools that allow users to analyse and annotate the charts."
enterprise: true
framework: vue
version: "14.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/financial-charts/"
    - title: "Configuration"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/financial-charts-configuration/"
    - title: "Range Buttons"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/range-buttons/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Financial Charts - Toolbar

The Toolbar contains tools that allow users to analyse and annotate the charts.

## Chart Type Selection

Users can choose the series type used to display the price data.

[Video](https://www.ag-grid.com/charts/archive/14.2.0/_astro/chart-types.ywAOF0mq.mp4)

Available series types are Candlestick, Hollow Candlestick, OHLC, Line, Step Line, HLC and High Low.

## Lines

#### Lines Drawings

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgFinancialCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import { FinancialChartModule, ModuleRegistry } from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([FinancialChartModule]);

const ChartExample = defineComponent({
  template: `
    <ag-financial-charts
      :options="options"
    />
  `,
  components: {
    "ag-financial-charts": AgFinancialCharts,
  },
  setup(props) {
    const options = ref<AgFinancialChartOptions>({
      data: getData(),
      title: {
        text: "Line Drawings",
      },
      rangeButtons: false,
      initialState: {
        annotations: [
          {
            type: "line",
            start: {
              x: {
                __type: "date",
                value:
                  "Thu Mar 21 2024 18:30:00 GMT+0000 (Greenwich Mean Time)",
              },
              y: 39859.35027982327,
            },
            end: {
              x: {
                __type: "date",
                value:
                  "Thu Mar 21 2024 18:39:00 GMT+0000 (Greenwich Mean Time)",
              },
              y: 39836.36176730486,
            },
            text: {
              label: "Trend line",
              position: "center",
              alignment: "center",
            },
            extendStart: true,
            extendEnd: true,
          },
          {
            type: "parallel-channel",
            height: 15.282400589101599,
            middle: {
              strokeWidth: 1,
              lineDash: [6, 5],
            },
            background: {
              fill: "#5090dc",
              fillOpacity: 0.2,
            },
            start: {
              x: {
                __type: "date",
                value:
                  "Thu Mar 21 2024 18:45:00 GMT+0000 (Greenwich Mean Time)",
              },
              y: 39831.539027982326,
            },
            end: {
              x: {
                __type: "date",
                value:
                  "Thu Mar 21 2024 18:59:00 GMT+0000 (Greenwich Mean Time)",
              },
              y: 39842.30854197349,
            },
            text: {
              label: "Parallel channel",
              position: "top",
              alignment: "left",
            },
            extendStart: true,
          },
          {
            type: "disjoint-channel",
            startHeight: 29.948914431675803,
            endHeight: 12.78416347381426,
            start: {
              x: {
                __type: "date",
                value:
                  "Thu Mar 21 2024 19:31:00 GMT+0000 (Greenwich Mean Time)",
              },
              y: 39843.62007363771,
            },
            end: {
              x: {
                __type: "date",
                value:
                  "Thu Mar 21 2024 19:22:00 GMT+0000 (Greenwich Mean Time)",
              },
              y: 39835.032798232695,
            },
            text: {
              label: "Disjoint channel",
              position: "top",
              alignment: "right",
            },
          },
          {
            type: "vertical-line",
            value: {
              __type: "date",
              value: "Thu Mar 21 2024 19:08:00 GMT+0000 (Greenwich Mean Time)",
            },
            text: {
              label: "Vertical line",
              position: "top",
              alignment: "center",
            },
            axisLabel: {
              enabled: true,
            },
          },
          {
            type: "horizontal-line",
            value: 39863.48858615611,
            text: {
              label: "Horizontal line",
              position: "center",
              alignment: "right",
            },
            axisLabel: {
              enabled: true,
            },
            strokeWidth: 3,
            lineStyle: "dotted",
          },
        ],
      },
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Lines Drawings](https://www.ag-grid.com/charts/archive/14.2.0/vue3/financial-charts-toolbar/examples/line-drawings/)

Line types available are:

- **Trend Line**: A single line between two points on the chart.
- **Horizontal Line**: A horizontal line across the entire chart. There is also an optional label over the axis.
- **Vertical Line**: A vertical line across the entire chart. There is also an optional label over the axis.
- **Parallel Channel**: Two parallel lines, with a fill between them and an optional centre line as well.
- **Disjoint Channel**: Two lines which do not need to be parallel, with a fill between them.

Stroke and fill colours, stroke width and line style are fully customisable by the user.

### Line and Channel Labels

Users can add labels to their lines using the options available from the 'Settings' button or by double-clicking a line or channel. These options allow styling and positioning the labels.

### Extending Lines and Channels

Users can extend one or both ends of lines and channels to infinity. This is done using the options available from the 'Settings' button or by double-clicking a line or channel.

## Annotations

#### Text Annotations

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgFinancialCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import { FinancialChartModule, ModuleRegistry } from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([FinancialChartModule]);

const ChartExample = defineComponent({
  template: `
    <ag-financial-charts
      :options="options"
    />
  `,
  components: {
    "ag-financial-charts": AgFinancialCharts,
  },
  setup(props) {
    const options = ref<AgFinancialChartOptions>({
      data: getData(),
      title: {
        text: "Text Annotations",
      },
      rangeButtons: false,
      initialState: {
        annotations: [
          {
            type: "text",
            text: "Text",
            x: {
              __type: "date",
              value: "Thu Mar 21 2024 19:21:00 GMT+0000 (Greenwich Mean Time)",
            },
            y: 39851.06756756757,
          },
          {
            type: "comment",
            text: "Comment",
            x: {
              __type: "date",
              value: "Thu Mar 21 2024 19:06:00 GMT+0000 (Greenwich Mean Time)",
            },
            y: 39844.91891891892,
          },
          {
            type: "callout",
            text: "Callout",
            start: {
              x: {
                __type: "date",
                value:
                  "Thu Mar 21 2024 18:31:00 GMT+0000 (Greenwich Mean Time)",
              },
              y: 39856.820512820515,
            },
            end: {
              x: {
                __type: "date",
                value:
                  "Thu Mar 21 2024 18:39:00 GMT+0000 (Greenwich Mean Time)",
              },
              y: 39859.282051282054,
            },
          },
          {
            type: "note",
            text: "Note",
            x: {
              __type: "date",
              value: "Thu Mar 21 2024 18:54:00 GMT+0000 (Greenwich Mean Time)",
            },
            y: 39843.28205128205,
          },
        ],
      },
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Text Annotations](https://www.ag-grid.com/charts/archive/14.2.0/vue3/financial-charts-toolbar/examples/text-annotations/)

Annotation types available are:

- **Text**: Simple text string displayed on the chart.
- **Comment**: Text within a comment box.
- **Callout**: Text within a box, with a callout arrow anchored to a specific position on the chart.
- **Note**: An icon on the chart, with text displayed on hover.

Add a new line within annotations by pressing `⇧ Shift`+`↵ Enter`.

## Arrows

#### Arrow Drawings

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgFinancialCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import { FinancialChartModule, ModuleRegistry } from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([FinancialChartModule]);

const ChartExample = defineComponent({
  template: `
    <ag-financial-charts
      :options="options"
    />
  `,
  components: {
    "ag-financial-charts": AgFinancialCharts,
  },
  setup(props) {
    const options = ref<AgFinancialChartOptions>({
      data: getData(),
      title: {
        text: "Arrow Drawings",
      },
      rangeButtons: false,
      initialState: {
        annotations: [
          {
            type: "arrow",
            start: {
              x: {
                __type: "date",
                value:
                  "Thu Mar 21 2024 18:25:00 GMT+0000 (Greenwich Mean Time)",
              },
              y: 39870.926928281464,
            },
            end: {
              x: {
                __type: "date",
                value:
                  "Thu Mar 21 2024 18:44:00 GMT+0000 (Greenwich Mean Time)",
              },
              y: 39827.35453315291,
            },
          },
          {
            type: "arrow-up",
            x: {
              __type: "date",
              value: "Thu Mar 21 2024 18:56:00 GMT+0000 (Greenwich Mean Time)",
            },
            y: 39842.13125845738,
          },
          {
            type: "arrow-down",
            x: {
              __type: "date",
              value: "Thu Mar 21 2024 19:11:00 GMT+0000 (Greenwich Mean Time)",
            },
            y: 39814.188092016244,
          },
        ],
      },
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Arrow Drawings](https://www.ag-grid.com/charts/archive/14.2.0/vue3/financial-charts-toolbar/examples/arrow-drawings/)

Arrow types available are:

- **Arrow**: An arrow extending between two points on the chart.
- **Arrow Up**: A fixed size up arrow in a specific position on the chart.
- **Arrow Down**: A fixed size down arrow in a specific position on the chart.

## Fibonacci Tools

#### Fibonacci Tools

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgFinancialCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import { FinancialChartModule, ModuleRegistry } from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([FinancialChartModule]);

const ChartExample = defineComponent({
  template: `
    <ag-financial-charts
      :options="options"
    />
  `,
  components: {
    "ag-financial-charts": AgFinancialCharts,
  },
  setup(props) {
    const options = ref<AgFinancialChartOptions>({
      data: getData(),
      title: {
        text: "Fibonacci Tools",
      },
      rangeButtons: false,
      initialState: {
        annotations: [
          {
            type: "fibonacci-retracement",
            start: {
              x: {
                __type: "date",
                value: "2024-03-21T19:30:00.000Z",
              },
              y: 39839.65593310556,
            },
            end: {
              x: {
                __type: "date",
                value: "2024-03-21T19:12:00.000Z",
              },
              y: 39830.30360752416,
            },
          },
          {
            type: "fibonacci-retracement-trend-based",
            endRetracement: {
              x: {
                __type: "date",
                value: "2024-03-21T18:59:00.000Z",
              },
              y: 39824.246612868774,
            },
            start: {
              x: {
                __type: "date",
                value: "2024-03-21T18:38:00.000Z",
              },
              y: 39822.62080641716,
            },
            end: {
              x: {
                __type: "date",
                value: "2024-03-21T18:47:00.000Z",
              },
              y: 39830.20790319135,
            },
          },
        ],
      },
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Fibonacci Tools](https://www.ag-grid.com/charts/archive/14.2.0/vue3/financial-charts-toolbar/examples/fibonacci-tools/)

- **Fibonacci Retracement**: Multiple Fibonacci bands based on the distance between two points on the chart. Users have the option to choose how many bands to show.
- **Fibonacci Trend Based**: Multiple Fibonacci bands derived from the proportional relationships between three key points, capturing potential support and resistance zones along the trend. Users have the option to choose how many bands to show.

## Measuring Tools

#### Measuring Tools

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgFinancialCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import { FinancialChartModule, ModuleRegistry } from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([FinancialChartModule]);

const ChartExample = defineComponent({
  template: `
    <ag-financial-charts
      :options="options"
    />
  `,
  components: {
    "ag-financial-charts": AgFinancialCharts,
  },
  setup(props) {
    const options = ref<AgFinancialChartOptions>({
      data: getData(),
      title: {
        text: "Measuring Tools",
      },
      rangeButtons: false,
      initialState: {
        annotations: [
          {
            type: "date-range",
            extendBelow: true,
            text: {
              label: "Date Range",
              position: "top",
              alignment: "center",
            },
            start: {
              x: {
                __type: "date",
                value:
                  "Thu Mar 21 2024 18:29:00 GMT+0000 (Greenwich Mean Time)",
              },
              y: 39863.005115089516,
            },
            end: {
              x: {
                __type: "date",
                value:
                  "Thu Mar 21 2024 18:41:00 GMT+0000 (Greenwich Mean Time)",
              },
              y: 39840.089514066494,
            },
          },
          {
            type: "price-range",
            text: {
              label: "Price Range",
              position: "top",
              alignment: "right",
            },
            start: {
              x: {
                __type: "date",
                value:
                  "Thu Mar 21 2024 18:57:00 GMT+0000 (Greenwich Mean Time)",
              },
              y: 39822.54475703325,
            },
            end: {
              x: {
                __type: "date",
                value:
                  "Thu Mar 21 2024 18:49:00 GMT+0000 (Greenwich Mean Time)",
              },
              y: 39839.373401534525,
            },
          },
          {
            type: "date-price-range",
            text: {
              label: "Date and Price Range",
              position: "center",
              alignment: "left",
            },
            start: {
              x: {
                __type: "date",
                value:
                  "Thu Mar 21 2024 19:02:00 GMT+0000 (Greenwich Mean Time)",
              },
              y: 39834.62915601023,
            },
            end: {
              x: {
                __type: "date",
                value:
                  "Thu Mar 21 2024 19:31:00 GMT+0000 (Greenwich Mean Time)",
              },
              y: 39844.833759590794,
            },
          },
        ],
      },
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Measuring Tools](https://www.ag-grid.com/charts/archive/14.2.0/vue3/financial-charts-toolbar/examples/measuring-tools/)

Measuring Tools available are:

- **Measure**: A quick measuring tool, which measures both the date and price range. This is removed when the user clicks away on the chart.
- **Date Range**: Measures the time difference and number of bars between two points on the chart. Also shows the sum of the volume between the two points if `volume` is enabled.
- **Price Range**: Measures the price difference between two points on the chart. This is displayed both as an absolute value and as a percentage.
- **Date and Price**: Combines both the Date and Price Range measures.

## Keyboard Shortcuts

The following keyboard shortcuts can be used with Financial Charts.

- `^ Ctrl`+`Z` will undo any drawing and annotation actions.
- `^ Ctrl`+`Y` will redo any undo actions.
- `^ Ctrl`+`C` will copy the selected drawing or annotation.
- `^ Ctrl`+`V` will paste the copied drawing or annotation.
- `Delete` or `⌫ Backspace` will delete the selected item.
- Arrow keys (`←` `↑` `→` `↓`) will move the selected drawing or annotation by 1 pixel.  
  Use in combination with `^ Ctrl` or `⇧ Shift` to move by 10 pixels.
- Holding down `⇧ Shift` whilst creating a drawing or dragging a handle will snap it to the nearest 45° angle.

## Save & Restore

Drawings and Annotations can be saved, restored and programmatically initialised and modified, using the [Chart State API](https://www.ag-grid.com/charts/archive/14.2.0/vue/api-state/).

## Customisation

#### Annotation Customisation

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgFinancialCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import { FinancialChartModule, ModuleRegistry } from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([FinancialChartModule]);

const ChartExample = defineComponent({
  template: `
    <ag-financial-charts
      :options="options"
    />
  `,
  components: {
    "ag-financial-charts": AgFinancialCharts,
  },
  setup(props) {
    const options = ref<AgFinancialChartOptions>({
      data: getData(),
      title: {
        text: "Customisation",
      },
      rangeButtons: false,
      theme: {
        overrides: {
          common: {
            annotations: {
              line: {
                stroke: "lime",
                strokeWidth: 3,
                lineDash: [3, 4],
              },
              "parallel-channel": {
                stroke: "red",
                strokeWidth: 4,
                background: {
                  fill: "red",
                },
                middle: {
                  strokeOpacity: 0,
                },
              },
              comment: {
                fill: "orange",
                color: "blue",
                stroke: "blue",
                strokeWidth: 2,
              },
            },
          },
        },
      },
      initialState: {
        annotations: [
          {
            type: "parallel-channel",
            height: 83.55795148247944,
            start: {
              x: {
                __type: "date",
                value:
                  "Tue Sep 19 2023 00:00:00 GMT+0100 (British Summer Time)",
              },
              y: 4401.88679245283,
            },
            end: {
              x: {
                __type: "date",
                value:
                  "Thu Oct 05 2023 00:00:00 GMT+0100 (British Summer Time)",
              },
              y: 4279.245283018868,
            },
          },
          {
            type: "line",
            start: {
              x: {
                __type: "date",
                value:
                  "Tue Sep 05 2023 00:00:00 GMT+0100 (British Summer Time)",
              },
              y: 4507.681940700809,
            },
            end: {
              x: {
                __type: "date",
                value:
                  "Fri Oct 13 2023 00:00:00 GMT+0100 (British Summer Time)",
              },
              y: 4331.805929919137,
            },
          },
          {
            type: "comment",
            text: "Comment",
            visible: true,
            x: {
              __type: "date",
              value: "Tue Aug 22 2023 00:00:00 GMT+0100 (British Summer Time)",
            },
            y: 4261.725067385445,
          },
        ],
      },
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Annotation Customisation](https://www.ag-grid.com/charts/archive/14.2.0/vue3/financial-charts-toolbar/examples/annotation-customisation/)

To customise the look of Drawings and Annotations, use [Theme Override Options](https://www.ag-grid.com/charts/archive/14.2.0/themes-api/#reference-AgChartTheme-overrides-common-annotations).

```js
{
    theme: {
        overrides: {
            common: {
                annotations: {
                    line: {
                        stroke: 'lime',
                        strokeWidth: 3,
                        lineDash: [3, 4],
                    },
                    'parallel-channel': {
                        stroke: 'red',
                        strokeWidth: 4,
                        background: {
                            fill: 'red',
                        },
                        middle: {
                            strokeOpacity: 0,
                        },
                    },
                    comment: {
                        fill: 'orange',
                        color: 'blue',
                        strokeWidth: 4,
                    },
                },
            },
        },
    },
}
```
